<?php
class NSRCLernkorbBackendOptions extends NSRCLernkorbOptions {
    const OPTIONS = array(
        'netsource_anmelden_text', 
        'netsource_farben_lernkorb',
        'netsource_code_kreis_lernkorb',
        'netsource_code_teil_lernkorb', 
        'netsource_code_lernerli',
        'netsource_code_filterung',
        'netsource_css_lernkorb',
        'netsource_lernwunschkorb_anmelden',
        'netsource_lernwunschkorb_keine',
        'netsource_lernwunschkorb_delete',
        'netsource_lernwunschkorb_titel',
        'netsource_lernwunschkorb_titel_druck',
        'netsource_lernwunschkorb_zuruecksetzen',
    );

    function nsrc_add_pluginlinks ( $actions ) {
        $mylinks = array(
            '<a href="' . admin_url( 'admin.php?page=Lernkorb' ) . '">Settings</a>',
            '<a href="' . plugin_dir_url(__FILE__). 'Anleitung.pdf" target=_blank>Anleitung</a>',
        );
        $actions = array_merge( $actions, $mylinks );
        return $actions;
    }
    
    static function nsrc_add_adminmenu_description_lernkorb () {
        add_menu_page('LOA-Lernkorb','LOA-Lernkorb','manage_options','Lernkorb', array('NSRCLernkorbBackendOptions','add_nsrc_lernkorb_adminform'));
        add_submenu_page( 'Lernkorb', 'Verwaiste Lernerlis' , 'Verwaiste Lernerlis', 'manage_options', 'verwaiste_lernerlis', array('NSRCLernkorbQuicktags','nsrc_lernerli_get_missing_postmeta') );
    }
    static function _lernkorb_error($error) {
        print '<span class="lernkorb-error" style="color:red;font-weight:bold;">'.$error.'</span><br/>';
    }
    private function _lernkorb_save_option ($name) {
        // check user permissions
        if ( !current_user_can('manage_options') ) {
            die(__('Cheatin&#8217; uh?'));
            // if okay, store data
        } else {
            $value = htmlentities($_POST[$name]); //TODO ggf. weiterer Schutz vor XSS?
            switch($name) {
                case "netsource_farben_lernkorb":
                    //TODO eventuell Format abfragen?
                    //["221,221,221","auswählen"],["251,185,0","beobachten"],["238,114,37","üben"],["174,226,227","können"],["53,183,184","bestätigt"],["0,99,175","weitergeben"]
//                     if( ! empty($value) && ! preg_match('/^(\[\\\"\d{1,3},\d{1,3},\d{1,3}\\\",\\\"[^\"]+\\\"\],?)+$/', $value) )
//                         return NSRCLernkorbBackendOptions::_lernkorb_error('Falsches Format für '.$name.', bitte Farben mit Bezeichnern im Format ["r1,g1,b1":"text1"],["r2,g2,b2":"text2"],... angeben.');
                    break;
            }
            update_option($name, $value);
            wp_cache_delete($name);
        }
    }

    static function add_nsrc_lernkorb_adminform() { ?>
<div class="wrap">
<?php 
	// if submit was pressed, process config data
	if ( isset($_POST['submit']) ) {
		// check user permissions
		if ( !current_user_can('manage_options') ) {
			die(__('Cheatin&#8217; uh?'));
		// if okay, store data
		} else {
		    foreach(NSRCLernkorbBackendOptions::OPTIONS as $o) {
		        NSRCLernkorbBackendOptions::_lernkorb_save_option($o);
		    }
		    echo "<b>Settings saved</b>";
		}
	} 
?>
	<form action="" method="post" id="netsource_lernkorb" style="margin: auto;">

		<h2>Texte</h2>
		<p><b><label>Text, wenn Nutzer nicht angemeldet aber Aneignungsstufen angezeigt werden (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_anmelden_text" id="netsource_anmelden_text" value="<?php echo  parent::get_option_value("netsource_anmelden_text", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_anmelden_text")); ?></div>

		<p><b><label>Text, wenn Nutzer nicht angemeldet und Lernwunschkorb aufruft (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_anmelden" id="netsource_lernwunschkorb_anmelden" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_anmelden", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_anmelden")); ?></div>

		<p><b><label>Text, wenn Nutzer keine Lernerlis im Lernwunschkorb hat (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_keine" id="netsource_lernwunschkorb_keine" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_keine", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_keine")); ?></div>

		<p><b><label>Titel Lernwunschkorb-Filterung (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_titel" id="netsource_lernwunschkorb_titel" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_titel", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_titel")); ?></div>

		<p><b><label>Titel Lernwunschkorb-Druck (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_titel_druck" id="netsource_lernwunschkorb_titel_druck" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_titel_druck", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_titel_druck")); ?></div>

		<p><b><label>Titel Lernwunschkorb-Filterung zur&uuml;cksetzen (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_zuruecksetzen" id="netsource_lernwunschkorb_zuruecksetzen" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_zuruecksetzen", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_zuruecksetzen")); ?></div>

		<p><b><label>Aus Lernwunschkorb entfernen (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_lernwunschkorb_delete" id="netsource_lernwunschkorb_delete" value="<?php echo  parent::get_option_value("netsource_lernwunschkorb_delete", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_lernwunschkorb_delete")); ?></div>

		<h2>Lernerlis</h2>
		<p><b><label>Lernerli-Farben und -Texte (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
		<input type="text" name="netsource_farben_lernkorb" id="netsource_farben_lernkorb" value="<?php echo  parent::get_option_value("netsource_farben_lernkorb", false); ?>"/>
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_farben_lernkorb")); ?></div>

		<h2>CSS und Javascript (f&uuml;r Fortgeschrittene)</h2>
		<p><b><label>CSS (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_css_lernkorb" id="netsource_css_lernkorb" cols="100" rows="10"><?php echo  parent::get_option_value("netsource_css_lernkorb", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_css_lernkorb")); ?></div>

		<p><b><label>Javascript - Generierung Lernerli (kompletter Kreis) (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_code_lernerli" id="netsource_code_lernerli" cols="100" rows="10"><?php echo  parent::get_option_value("netsource_code_lernerli", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_code_lernerli")); ?></div>

		<p><b><label>Javascript - Generierung Lernkreis (Kreis aus St&uuml;cken) (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_code_kreis_lernkorb" id="netsource_code_kreis_lernkorb" cols="100" rows="10"><?php echo  parent::get_option_value("netsource_code_kreis_lernkorb", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_code_kreis_lernkorb")); ?></div>

		<p><b><label>Javascript - Generierung Kreisstück (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_code_teil_lernkorb" id="netsource_code_teil_lernkorb" cols="100" rows="10"><?php echo parent::get_option_value("netsource_code_teil_lernkorb", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_code_teil_lernkorb")); ?></div>

		<p><b><label>Javascript - Generierung Filterung (bitte leer lassen, um den Standard zu nutzen)</label></b></p>
	  	<textarea name="netsource_code_filterung" id="netsource_code_filterung" cols="100" rows="10"><?php echo parent::get_option_value("netsource_code_filterung", false); ?></textarea> 
		<div style="color:darkslateblue;"><?php echo  nl2br(parent::get_option_value_default("netsource_code_filterung")); ?></div>

		<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Settings&raquo;'); ?>" /></p>
		
	</form>
</div>
<?php
    }
    
}//class
?>