<?php
class NSRCLernkorbFrontendShortcodes extends Lernkorb {

    /**
     * Set Body class "lernwunschkorb" / "lernerli" if content contains shortcode
     */
    static function nsrc_css_class_shortcode($classes) {
        $content = get_the_content();
        if( has_shortcode($content, self::LERNERLI_id) ) {
            $classes = array_merge( $classes, array( self::LERNERLI_id ) );
        }
        if( has_shortcode($content, self::LERNWUNSCHKORB_id) ) {
            $classes = array_merge( $classes, array( self::LERNWUNSCHKORB_id ) );
        }
        return $classes;
    }
    
    /**
     * Generate "lernkreis" (all lernerli peaces in one - for user) for shortcode
     */
    static function nsrc_lernkreis_shortcode_user($atts, $teile = null ) {
        return '
        <div id="lernkorb_lernkreis_'. $atts["id"] .'" class="lernkreis">
            <script type="text/javascript">
            new Lernkreis(\''. $atts["id"] .'\', '.$teile.');
            </script>
        </div>
        ';
    }
    function getCurrentFilterUrl($withQuery = true)
    {
        $protocol = ($_SERVER['HTTPS'] === "on")? 'https' : 'http';
        $uri = $protocol . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
        
        $uri =  $withQuery ? $uri : str_replace('?' . $_SERVER['QUERY_STRING'], '', $uri);
        $uri .= "?";
        if(empty($_GET["filterLernerliStufe"])) $_GET["filterLernerliStufe"] = array();
        foreach(array_unique($_GET["filterLernerliStufe"]) as $l) {
            $uri .= "filterLernerliStufe[]=".intval($l)."&";
        }
        return $uri;
    }
    
    /**
     * Generate "lernerli_kreis" (one for each lernerli) for shortcode
     */
    static function nsrc_lernkreis_shortcode_post($atts, $content = null ) {
        $user_id = 0;
        $active = -1;
        $lernerli =  intval( preg_replace("/[“″\"']/","", html_entity_decode($atts["id"]) ) );
        $return = '
        <div id="lernkorb_lernerli_content_'. $lernerli .'" class="lernerli_content">
            '.$content.'
        </div>';
        $message = "";

        $url = self::getCurrentFilterUrl(false);
        if( ! is_user_logged_in() ) {
            $message = NSRCLernkorbOptions::get_option_value("netsource_anmelden_text");
            $url = wp_login_url();
        }
       //$active = 0;
        if( is_user_logged_in() ) {
            $user = wp_get_current_user();
            $user_id = $user->ID;
            //check if current user has activated current lernerli 
            $usermetas = get_user_meta($user_id, Lernkorb::LERNERLI_2_param);
            foreach($usermetas as $u) {
                list($l,$s) = explode(":", $u);
                if( intval($l) == $lernerli ) {
                    $active = intval($s);
                }
            }
        }
        $return .= '
        <div id="lernkorb_lernerli_'. $lernerli .'" class="lernerli_kreise">
            <script type="text/javascript">
        	window.addEventListener("load",function(event) {
                    new Lernerlies("lernkorb_lernerli_'. $lernerli .'",'. $lernerli .', '.$active.', '.$user_id.', "'.$url.'", "'.$message.'", "'.NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_delete").'" );
            },false);
            </script>
        </div>
        ';
        if( method_exists ("Lernzirkel_Frontend","nsrc_lernzirkel_chat_shortcode") ) 
            $return .= Lernzirkel_Frontend::nsrc_lernzirkel_chat_shortcode(array("lernerli_id" => $lernerli));
        return $return;
    }
    
    
    /**
     * In post and postmeta show lernkreise-Shortcode for lernerli
     */
    function nsrc_lernkreise_post($content) {
        if( ! is_admin() ) {
            $content = str_replace("lernerli]", "lernerli_kreis]", $content);
            $content = str_replace("[lernerli", "[lernerli_kreis", $content);
        }
        return $content;
    }
    
    /**
     * Add Lernkreis to title for given post for current user
     * Currently not in use / not needed
     * use add_filter( 	'the_title',        			array('NSRCLernkorbFrontendShortcodes','nsrc_lernkreis_title'), 10, 2 );
     */
    function nsrc_lernkreis_title($title, $id) {
        if(  is_user_logged_in() ) {
            return self::nsrc_lernkreis_post($id).$title;
        }
        return $title;
    }
    
    /**
     * Generate Lernkreis for given post
     */
    private function nsrc_lernkreis_post($postid) {
        $user = wp_get_current_user();
        $user_id = $user->ID;
        $teile = "";
        $postmeta = parent::get_complete_meta( $postid, parent::LERNERLI_id );
        foreach($postmeta as $pm) {
            $teile .= "{id:".$pm->meta_id.",";
            //check if current user has activated lernerlies
            $usermetas = get_user_meta($user_id, Lernkorb::LERNERLI_2_param);
            foreach($usermetas as $u) {
                list($lernerli,$stufe) = explode(":", $u);
                //check if active 
                if( $lernerli == $pm->meta_id ) {
                    $teile .= "colorindex:$stufe},";
                    break;
                }
            }
            //wenn nicht aktiv
            $teile = preg_replace("/([^\}]),$/", "$1,colorindex:-1},", $teile);
        }
        $teile = preg_replace("/,$/", "", $teile);
        return self::nsrc_lernkreis_shortcode_user( array("id" => $postid), "[".$teile."]" );
    }
    
    /**
     * Shortcode to show lernwunschkorb for current user
     */
    function nsrc_lernwunschkorb_shortcode() {
        if( is_user_logged_in() ) {
            $user = wp_get_current_user();
            $user_id = $user->ID;

            $url = self::getCurrentFilterUrl(false);
            $filter = array();
            if(empty($_GET["filterLernerliStufe"])) $_GET["filterLernerliStufe"] = array();
            foreach(array_unique($_GET["filterLernerliStufe"]) as $l) {
                $filter[] = intval($l);
            }
            
            $pids = parent::get_lernerliposts_for_user($user_id, $filter);
            $return = '<div class="lernwunschkorb">';
            $return .= '
<div id="lernwunschkorbfilterung" class="lernwunschkorbfilterung">
    <h2 class="lernwunschkorbfilterung">'.NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_titel").'</h2><h2 class="lernwunschkorbfilterung_druck" style="display:none">'.NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_titel_druck").'</h2>
    <script type="text/javascript">
        new Filterung("lernwunschkorbfilterung",['.implode(",",array_unique($_GET["filterLernerliStufe"])).'], "'.$url.'");
    </script>
';
            if(! empty($_GET["filterLernerliStufe"]) ) {
                $return .= '
    <a href="'.get_permalink().'" class="lernwunschkorbfilterung">'.NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_zuruecksetzen").'</a>';
            }
            $return .= '
</div>';
            global $post;
            $postcopy = $post;
            foreach( $pids as $pid ) {
                $content = "";
                $post = get_post($pid);
                setup_postdata($post);
                $matches = array();
                $pattern = "\[(".self::LERNERLI_id.")[^\]]*\][^\[]+\[\/(".self::LERNERLI_id.")\]";
                preg_match_all('/'.$pattern.'/s', get_the_content(), $matches);
                foreach( $matches[0] as $m ) {
                    $content .= do_shortcode(self::nsrc_lernkreise_post($m)); // execute that shortcode we've found
                }
                $postmeta = parent::get_complete_meta_post( $pid );
                foreach($postmeta as $pm) {
                    $matches = array();
                    preg_match_all('/'.$pattern.'/s', $pm->meta_value, $matches);
                    foreach( $matches[0] as $m ) {
                        $content .= do_shortcode(self::nsrc_lernkreise_post($m)); // execute that shortcode we've found
                    }
                }
                $return .= '
            <div class="lernwunschkorb_lernkreis_wrapper">
                <div class="lernwunschkorb_lernkreis">
                ' . self::nsrc_lernkreis_post($pid) . '
                    <div class="lernkreis_title">' . get_the_title() . '</div>
                </div>
                <div class="lernkreis_content toggle_lernkreise">'.$content.'
	                <a href="'.get_the_permalink().'" class="lernkreis_zumBeitrag">zum Beitrag</a>
				</div>
            </div>
            ';
            }
            if( empty($pids) ) $return .= NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_keine");
            $return .= '</div>';
            $post = $postcopy;
            setup_postdata($post);
            return $return;
        } else {
            return NSRCLernkorbOptions::get_option_value("netsource_lernwunschkorb_anmelden");
        }
    }
    
    static function nsrc_toogle_javascript() { ?>
    <script type="text/javascript">
        jQuery(document).ready(function( $ ) {
            $('div.lernkreis_title').each(function() {
                if(	$(this).children("a.toggle_lernkreise").length == 0 )
                    $(this).html('<a href="#" class="toggle_lernkreise">'+$(this).html()+'</a>');
                    $("div.lernkreis_content.toggle_lernkreise").css('visibility','hidden');
            });
            $('a.toggle_lernkreise').click(function(event) {
                    event.preventDefault();
                    var div = $(this).parent("div").parent("div").parent("div");
                    div.toggleClass("active");
            });
        });
	</script>
	<?php 
    }
}
?>