<?php 
class NSRCLernkorbQueryvars extends Lernkorb {
    
    /**
     * check if there is a valid user id, stufe and lernerli_id, if so, add it to user_meta 
     */
    static function nsrc_add_lernerli_2_user( $wp_query ) {
        if (($user_id = intval( get_query_var(Lernkorb::LERNERLI_2user_param) ) ) > 0 ) {
            if (($lernerli_id = intval( get_query_var(Lernkorb::LERNERLI_2_param) ) ) > 0 ) {
                if (($stufe_id = intval( get_query_var(Lernkorb::LERNERLI_2_stufe) ) ) > -1 ) {
                    //check if usermeta already exists for given lernerli and if so delete it befor saving
                    $usermetas = get_user_meta($user_id, Lernkorb::LERNERLI_2_param);
                    foreach($usermetas as $u) {
                        list($l,$s) = explode(":", $u);
                        if( intval($l) == $lernerli_id ) {
                            delete_user_meta( $user_id, Lernkorb::LERNERLI_2_param, $u);
                            break;
                        }
                    }
                    if(get_query_var(Lernkorb::LERNERLI_2_stufe) !== "delete")
                        add_user_meta($user_id, Lernkorb::LERNERLI_2_param, $lernerli_id.":".$stufe_id, false);
                } 
            }
        }
    }

    /**
     * Allow the following params in the URL to add lernerli to usermeta
     */
    static function nsrc_add_query_vars($vars) {
        $vars[] .= Lernkorb::LERNERLI_2user_param;
        $vars[] .= Lernkorb::LERNERLI_2_param;
        $vars[] .= Lernkorb::LERNERLI_2_stufe;
        
        return $vars;
    }
    
}
?>