<?php
//TODO WICHTIG: abfragen, ob lernerli noch von user genutzt wird, bevor post oder postmeta gespeichert wird!

class NSRCLernkorbQuicktags extends Lernkorb {

    /**
     * add button for lernerli-Tag to the html editor
     */ 
    static function nsrc_lernerli_quicktag() {
        if ( wp_script_is( 'quicktags' ) ) {
            ?>
        <script type="text/javascript">
        QTags.addButton( '<?php echo self::LERNERLI_id;?>_add', 'Lernerli', '[<?php echo self::LERNERLI_id;?>]', '[/<?php echo self::LERNERLI_id;?>]', 'l', '<?php echo self::LERNERLI_title;?>, id wird automatisch gesetzt', 1 );
        </script>
        <?php
        }
    }
    
    /**
     * add button for lernwunschkorb-Tag to the html editor
     */
    static function nsrc_lernwunschkorb_quicktag() {
        if ( wp_script_is( 'quicktags' ) ) {
            ?>
        <script type="text/javascript">
        QTags.addButton( '<?php echo self::LERNWUNSCHKORB_id;?>_add', 'Lernwunschkorb', '[<?php echo self::LERNWUNSCHKORB_id;?>]', '', 'w', '<?php echo self::LERNWUNSCHKORB_title;?>', 1 );
        </script>
        <?php
        }
    }
    
    /**
     * On save of post, add ids to [lernerli]-Tags
     * @see nsrc_lernerli_quicktag_update_postmeta
     */
    static function nsrc_lernerli_quicktag_save_post($post_ID, $post, $update) {
        if( $post->post_type === "revision") return;
        
        //check if there needs to be an id added
        $add_id = self::add_id_to_lernerli($post->post_content);
        
        //if so, add it to shortcode
        $add_count = 0;
        while( $add_id === true ) {
            if($add_count > 100) die("TO MUCH lernerlies 2");
            //new lernerli
            $id = add_post_meta( $post_ID, self::LERNERLI_id, "post");
            //save post content
            $post_content_new = self::add_id_to_lernerli($post->post_content,$id);
            $post->post_content = $post_content_new;
            
            //check if there is another one
            $add_id = self::add_id_to_lernerli($post->post_content);
            $add_count++;
        }
        
        //if there was a replacement, then update post
        if( $add_count > 0 ) wp_update_post( $post );

        //TODO besser als cron umsetzen?
        self::nsrc_lernerli_quicktag_tidyup_postmeta();
    }
    
    /**
     * On save of postmeta, add ids to [lernerli]-Tags
     * @see nsrc_lernerli_quicktag_save_post
     */
    static function nsrc_lernerli_quicktag_update_postmeta($meta_id, $object_id, $meta_key, $meta_value) {
        $meta_value_new = $meta_value;

        //check if there needs to be an id added
        $add_id = self::add_id_to_lernerli($meta_value_new);
        
        //if so, add it to shortcode
        $add_count = 0;
        while( $add_id === true ) {
            if($add_count > 100) die("TO MUCH lernerlies: 1");

            //replace lernerli in text
            $id = add_post_meta( $object_id, self::LERNERLI_id, "postmeta");
            $meta_value_new = self::add_id_to_lernerli( $meta_value_new, $id );

            //check if there is another one
            $add_id = self::add_id_to_lernerli( $meta_value_new );
            $add_count++;
        }
        
        //if there was a replacement, then update postmeta
        if( $add_count > 0 ) {
            update_metadata_by_mid( 'post', $meta_id, $meta_value_new, $meta_key);
        }

        //TODO besser als cron umsetzen?
        self::nsrc_lernerli_quicktag_tidyup_postmeta();
    }
    
    /**
     * Check if there is a [lernerli] tag without id in a text. If so and if id is given add it to the text and return it otherwise return true/false. 
     */
    static private function add_id_to_lernerli($text, $next_id=false) {
        //alte bzw. nicht existente IDs entfernen
        $matches = array();
        if( preg_match_all("|\[".self::LERNERLI_id."(\s+id=\"([\d]+)\")\]([^\[]+)\[\/".self::LERNERLI_id."\]|", $text, $matches)) {
            $preg_i = 0;
            foreach($matches[2] as $m) {
                $pid = get_metadata_by_mid( 'post', $m );
                if( empty($pid) || $pid->meta_key !== self::LERNERLI_id )  {
                    $text = str_replace(
                        $matches[1][$preg_i],
                        "",
                        $text
                    );
                }
                $preg_i++;
            }
        }
        
        //auf fehlende IDs prüfen
        $matches = array();
        if( preg_match_all("|\[".self::LERNERLI_id."\s*\]([^\[]+)\[\/".self::LERNERLI_id."\]|", $text, $matches)) {
            $preg_i = 0;
            foreach($matches[0] as $m) {
                if( $next_id === false ) {
                    return true;
                }
                else {
                    return str_replace(
                        $matches[0][$preg_i],
                        str_replace(
                            "[".self::LERNERLI_id."]",
                            "[".self::LERNERLI_id." id=\"".$next_id."\"]", 
                            $matches[0][$preg_i]),
                        $text
                    );
                }
                $preg_i++;
            }
        }
        return false;
    }
    
    //TODO besser als cron umsetzen?
    /**
     * Delete all postmeta for key lernerli that are not in use
     */
    static function nsrc_lernerli_quicktag_tidyup_postmeta() {
        global $wpdb;
        $sql = "select meta_id from wp_postmeta where meta_key='".self::LERNERLI_id."'";
        $ids = $wpdb->get_col( $sql );
        foreach($ids as $id) {
            $sql = "select count(*) from wp_posts where post_content like '%[".self::LERNERLI_id." id=\"$id\"]%' and post_type!='revision'";
            $count_post = $wpdb->get_var( $sql );
            if( intval($count_post) == 0 ) {
                $sql = "select count(*) from wp_postmeta where meta_value like '%[".self::LERNERLI_id." id=\"$id\"]%'";
                $count_postmeta = $wpdb->get_var( $sql );
                if( intval($count_postmeta) == 0 ) {
                    //$sql = "SELECT count(*) from ".$wpdb->usermeta." WHERE meta_key = \"".self::LERNERLI_id."\" AND meta_value like \"".$id.":%\"";
                    //$count_umeta = $wpdb->get_var( $sql );
                    //if( intval($count_umeta) == 0 ) {
                        $sql = "delete from ".$wpdb->postmeta." where meta_id=$id";
                        $wpdb->query($sql);
                    //}
                }
            }
        }
    }
    
    /**
     * Get all postmeta that are in use by user but no longer existant
     */
    static function nsrc_lernerli_get_missing_postmeta() {
        global $wpdb;
        print "<h2>Es werden Lernerlis von Nutzenden beobachtet, deren Inhalt aber gelöscht wurde:</h2>"; 
        $sql = "select * from ".$wpdb->usermeta." where meta_key='".self::LERNERLI_id."'";
        $usermetas = $wpdb->get_results( $sql );
        foreach($usermetas as $usermeta) {
            list($mid,$stufe) = explode(":",$usermeta->meta_value);
            
            $sql = "select count(*) from wp_posts where post_content like '%[".self::LERNERLI_id." id=\"$mid\"]%' and post_type!='revision'";
            $count_post = $wpdb->get_var( $sql );
            if( intval($count_post) == 0 ) {
                $sql = "select count(*) from wp_postmeta where meta_value like '%[".self::LERNERLI_id." id=\"$mid\"]%'";
                $count_postmeta = $wpdb->get_var( $sql );
                if( intval($count_postmeta) == 0 ) {
                    
                    print "<br/><strong>[".self::LERNERLI_id." id=\"$mid\"]</strong> ";
                    $sql = "select * from wp_posts where post_content like '%[".self::LERNERLI_id." id=\"$mid\"]%' limit 1";
                    $posts = $wpdb->get_results( $sql );
                    foreach($posts as $p) {
                        print "<a href=\"".get_edit_post_link($p->ID)."\" target=_blank>Zur Version</a>";
                    }
                    $sql = "select * from wp_postmeta where meta_value like '%[".self::LERNERLI_id." id=\"$mid\"]%'";
                    $postmetas = $wpdb->get_results( $sql );
                    foreach($postmetas as $pm) {
                        print "<a href=\"".get_edit_post_link($p->ID)."\" target=_blank>Zum Postmeta</a>";
                    }
                    
                    
                }
            }
        }
    }
    
}
?>